Structure p3d
  x.f
  y.f
  z.f
EndStructure
Global Dim dod.p3d(19)
Global Dim ic.p3d(12)
Global Dim icr.p3d(12)
Global c.f=#PI/180
Global ax=0
Global ay=0
Global az=0

Enumeration
  #ca
  #vax
  #vay
  #vaz
EndEnumeration

Procedure setxyz()
  
  ic(1)\x=0
  ic(1)\y=0
  ic(1)\z=Sqr(5)/2
  For j=0 To 4
    ic(j+2)\x=Cos(j*72*c)
    ic(j+2)\y=Sin(j*72*c)
    ic(j+2)\z=0.5
    ic(j+7)\x=Cos((36+j*72)*c)
    ic(j+7)\y=Sin((36+j*72)*c)
    ic(j+7)\z=-0.5
  Next j
  ic(12)\x=0
  ic(12)\y=0
  ic(12)\z=-Sqr(5)/2
  
EndProcedure

Procedure rotxyz()
  For i=1 To 12
    x.f=ic(i)\x
    y.f=ic(i)\y
    z.f=ic(i)\z
    ;      rotation around Z-axis :  (rotating the point X,Y,Z  A degrees)
    x1.f = Cos (az*c)*x - Sin (az*c)*y;     Xrotated = Cos (A)*X - Sin (A)*Y
    y1.f = Sin (az*c)*x + Cos (az*c)*y;     Yrotated = Sin (A)*X + Cos (A)*Y
                                      ;     Zrotated = Z
    x=x1
    y=y1
    ;Box(x1+320,y1+240,2,2,$FFFFFF)
    ; 
    ; rotation around X-axis :
    ;     Xrotated = X
    y1 = Cos (ax*c)*y - Sin (ax*c)*z;     Yrotated = Cos (A)*Y - Sin (A)*Z
    z1.f = Sin (ax*c)*y + Cos (ax*c)*z;     Zrotated = Sin (A)*Y + Cos (A)*Z
    y=y1
    z=z1
    ; rotation around Y-axis :
    x1 = Cos (ay*c)*x - Sin (ay*c)*z;     Xrotated = Cos (A)*X - Sin (A)*Z
                                    ;     Yrotated = Y
    z1 = Sin (ay*c)*x + Cos (ay*c)*z;     Zrotated = Sin (A)*X + Cos (A)*Z
    
    icr(i)\x=x1
    icr(i)\y=y1
    icr(i)\z=z1
  Next i
  ax=(ax+2)%360
  ay=(ay+1)%360
  az=(az+3)%360
  
EndProcedure

Procedure drawxyz()
  StartDrawing(CanvasOutput(#ca));ScreenOutput())
  Box(0,0,640,480,0)
  Restore icosavert
  r=200
  For i=0 To 19
    Read.l a
    Read.l b
    Read.l cc
    x1.f=(icr(a)\x)
    y1.f=(icr(a)\y)
    z1.f=(icr(a)\z)
    
    x2.f=(icr(b)\x)
    y2.f=(icr(b)\y);+240
    z2.f=(icr(b)\z)
    
    x3.f=(icr(cc)\x);+320
    y3.f=(icr(cc)\y);+240
    z3.f=(icr(cc)\z)
    
    xx.f=(x1+x2+x3)/3
    yy.f=(y1+y2+y3)/3
    zz.f=(z1+z2+z3)/3
    dod(i)\x=xx
    dod(i)\y=yy
    dod(i)\z=zz
    
    ;test for hidden faces      
    ;         Xn=(y1-y0)(z0-z2)-(z1-z0)(y0-y2)
    ;         Yn=(z1-z0)(x0-x2)-(x1-x0)(z0-z2)
    ;         Zn=(x1-x0)(y0-y2)-(y1-y0)(x0-x2)
    ;         normal:=(x1-x0)(y0-y2)-(y1-y0)(x0-x2);
    
    no.f=(x2-x1)*(y1-y3)-(y2-y1)*(x1-x3)
    If no>0
      x1=Int(x1*r)+320
      y1=Int(y1*r)+240
      x2=Int(x2*r)+320
      y2=Int(y2*r)+240
      x3=Int(x3*r)+320
      y3=Int(y3*r)+240
      
      LineXY(x1,y1,x2,y2,$FFFFFF)
      LineXY(x3,y3,x2,y2,$FFFFFF)
      LineXY(x1,y1,x3,y3,$FFFFFF)
      ;number
;       xx=(x1+x2+x3)/3
;       yy=(y1+y2+y3)/3
;       zz=(z1+z2+z3)/3
;       DrawText(xx,yy,Str(i),$FF00FF)
    EndIf
    
  Next i
  
  Restore dode
  For i=0 To 11
    Read.l a0.l
    Read.l a1.l
    Read.l a2.l
    Read.l a3.l
    Read.l a4.l
    x0.f=dod(a0)\x
    y0.f=dod(a0)\y
    x1.f=dod(a1)\x
    y1.f=dod(a1)\y
    x2.f=dod(a2)\x
    y2.f=dod(a2)\y
    x3.f=dod(a3)\x
    y3.f=dod(a3)\y
    x4.f=dod(a4)\x
    y4.f=dod(a4)\y
    If (x2-x1)*(y1-y3)-(y2-y1)*(x1-x3)>0
      x0=Int(x0*r)+320
      y0=Int(y0*r)+240
      x1=Int(x1*r)+320
      y1=Int(y1*r)+240
      x2=Int(x2*r)+320
      y2=Int(y2*r)+240
      x3=Int(x3*r)+320
      x4=Int(x4*r)+320
      y3=Int(y3*r)+240
      y4=Int(y4*r)+240
      
      LineXY(x1,y1,x0,y0,255)
      LineXY(x1,y1,x2,y2,255)
      LineXY(x2,y2,x3,y3,255)
      LineXY(x3,y3,x4,y4,255)
      LineXY(x0,y0,x4,y4,255)
    EndIf
  Next i
  StopDrawing() 
EndProcedure

If InitSprite() And OpenWindow(0,0,0,640,540,"Icosahedron+Dodecahedron",#PB_Window_SystemMenu|#PB_Window_ScreenCentered); And OpenWindowedScreen(WindowID(0),0,0,640,480,0,0,0) 
  CanvasGadget(#ca,0,0,640,480)
  TrackBarGadget(#vax,0,480,640,20,0,360)
  TrackBarGadget(#vay,0,500,640,20,0,360)
  TrackBarGadget(#vaz,0,520,640,20,0,360)
  setxyz()
  rotxyz()
  drawxyz()
  
  Repeat
    ev=WindowEvent()
    If GetAsyncKeyState_(#VK_ESCAPE) & $8000
      Break
    EndIf
    Sleep_(100/2) 
    rotxyz()
    drawxyz()
    
    If ev=#PB_Event_Gadget
      ;    Debug "ev"
      Select EventGadget()
        Case #vax,#vay,#vaz
          ax=GetGadgetState(#vax)
          ay=GetGadgetState(#vay)
          az=GetGadgetState(#vaz)
          SetWindowTitle(0,"ax:"+Str(ax)+",ay:"+Str(ay)+",az:"+Str(az))
          rotxyz()
          drawxyz()
      EndSelect
    EndIf
    ;FlipBuffers() 
  Until ev=#PB_Event_CloseWindow 
EndIf

DataSection
  icosavert:    
  Data.l	1,2,3,1,3,4,1,4,5,1,5,6,1,6,2;ok 15
  Data.l	2,6,11,3,2,7,6,5,10,5,4,9,4,3,8;ok 15
  Data.l	5,9,10,6,10,11,4,8,9,3,7,8,7,2,11;15
  Data.l 11,10,12,7,11,12,8,7,12,9,8,12,9,12,10;15
  dode:
  Data.l 0,1,2,3,4;0,4,3,2,1
  Data.l 0,4,5,14,6;0,6,14,5,4
  Data.l 4,3,7,11,5;4,5,11,7,3
  Data.l 3,2,8,10,7;3,7,10,8,2
  Data.l 2,1,9,12,8;2,8,12,9,1
  Data.l 1,0,6,13,9;1,9,13,6,0
  Data.l 9,13,17,18,12;9,12,18,17,13
  Data.l 6,14,16,17,13;6,13,17,16,14
  Data.l 5,11,15,16,14;5,14,16,15,11
  Data.l 7,10,19,15,11;7,11,15,19,10
  Data.l 8,12,18,19,10;8,10,19,18,12
  Data.l 17,16,15,19,18;17,18,19,15,16
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 123
; FirstLine = 94
; Folding = -
; Executable = dode.exe